/////////////////////////////////////////////////////////////////////////////
// LockHlpr.cpp : Implementation of DLL Exports.
//
//
//	  LockHlpr is a Browser Helper Object that watches for directory 
//    or folder changes in Exlorer, Folders, Internet Explorer, My Computer.
//    If the user has changed to a folder that is in the desktop file 
//    system then the cursor will change to a pad lock, and various
//    functions will be disabled.
//
//
//    Copyright (c) 1999 Ziff Davis, Inc. All rights reserved
//    First appeared in PC Magazine, US Edition, August, 1999
//                Programmed by Mark Sweeney
//

#include "stdafx.h"
#include "resource.h"
#include "initguid.h"

#include "lockhlpr.h"
#include "lockhlpr_i.c"

#include "LockHlprObj.h"


BOOL bOKtoUnLoad = 1;

CComModule _Module;		 
HINSTANCE g_hInstance;

BEGIN_OBJECT_MAP(ObjectMap)
	OBJECT_ENTRY(CLSID_LockHlprObj, CLockHlprObj)
END_OBJECT_MAP()

/////////////////////////////////////////////////////////////////////////////
// DLL Entry Point

extern "C"
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{

	g_hInstance = hInstance;
	if (dwReason == DLL_PROCESS_ATTACH )
	{
		DEBUGOUT( _T("DLLMain LockHlpr  DLL_PROCESS_ATTACH") );
		_Module.Init(ObjectMap, hInstance );
		DisableThreadLibraryCalls( hInstance );
		
	}
	
	if (dwReason == DLL_PROCESS_DETACH)
	{
		DEBUGOUT( _T("DLLMain LockHlpr  DLL_PROCESS_DETACH" ) );
		_Module.Term();
	
	}
	return TRUE;    
}

/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

STDAPI DllCanUnloadNow(void)
{
	return (_Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
	return _Module.GetClassObject(rclsid, riid, ppv);
}

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry

STDAPI DllRegisterServer(void)
{
	// registers object, typelib and all interfaces in typelib
	return _Module.RegisterServer(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
	_Module.UnregisterServer();
	return S_OK;
}


